# Description of variables JSON files with comments

## J1
- `mtom` [kg]: Maximum takeoff weight
- `oem` [kg]: Operational empty weight
- `eff` [-]: Uses propellor efficiency so is assumed to be 0.9
- `diskloading` [-]: Disk loading
- `v_cruise` [m/s]: Cruise speed
- `v_max` [m/s]: Maximum speed
- `v_stall` [m/s]: Stall speed
- `loadfactor` [-]: Load factor
- `h_hover` [m]: Hover height
- `roc` [m/s]: Rate of climb
- `cl_cruise` [-]: Lift coefficient at cruise
- `clmax` [-]: Maximum lift coefficient
- `cd` [-]: Drag coefficient
- `cd0` [-]: Parasitic drag coefficient
- `e` [-]: Oswald efficiency factor
- `A` [-]: Wing aspect ratio
- `sweep_le` [deg]: Leading edge wing sweep 
- `S`[m^2]: Wing surface area
- `StotS` [-]: Total area including fuselage over wing surface area
- `ducted_bool`: Does this concept use ducted fans or open propellers (1=ducted, 0=openprop)


## L1
- `mtom` [kg]: Maximum takeoff weight
- `oem` [kg]: Operational empty weight
- `l_fuse` [m]: Length of fuselage
- `w_fuse` [m]: Width of fuselage
- `eff` [-]: Uses ducted fans efficiency so is assumed to be 0.8
- `diskloading` [-]: Disk loading
- `v_cruise` [m/s]: Cruise speed
- `v_max` [m/s]: Maximum speed
- `v_stall` [m/s]: Stall speed
- `loadfactor` [-]: Load factor
- `h_hover` [m]: Hover height
- `roc` [m/s]: Rate of climb
- `cl_cruise` [-]: Lift coefficient at cruise
- `clmax` [-]: Maximum lift coefficient
- `cd` [-]: Drag coefficient
- `cd0` [-]: Parasitic drag coefficient
- `e` [-]: Oswald efficiency factor
- `b1` [m]: Span of the front wing
- `b2` [m]: Span of the rear wing
- `A` [-]: Wing aspect ratio
- `S1` [m^2]: Wing area of the front wing
- `S2` [m^2]: Wing area of the rear wing
- `S` [m^2]: Total wing area
- `c_root1` [m]: Root chord of the front wing
- `c_root2` [m]: Root chord of the rear wing
- `c_tip1` [m]: Tip chord of the front wing
- `c_tip2` [m]: Tip chord of the rear wing
- `sweep_le1` [deg]: Sweep angle of the leading edge of the front wing
- `sweep_le2` [deg]: Sweep angle of the leading edge of the rear wing
- `taper1` [-]: Taper ratio of the front wing
- `taper2` [-]: Taper ratio of the rear wing
- `StotS` [-]: Total area including fuselage over wing surface area
- `ducted_bool`: Does this concept use ducted fans or open propellers (1=ducted, 0=openprop)


## W1
- `mtom` [kg]: Maximum takeoff weight
- `oem` [kg]: Operational empty weight
- `eff` [-]: Uses propellor efficiency so is assumed to be 0.9
- `diskloading` [-]: Disk loading
- `v_cruise` [m/s]: Cruise speed
- `v_max` [m/s]: Maximum speed
- `v_stall` [m/s]: Stall speed
- `loadfactor` [-]: Load factor
- `h_hover` [m]: Hover height
- `roc` [m/s]: Rate of climb
- `cl_cruise` [-]: Lift coefficient at cruise
- `clmax` [-]: Maximum lift coefficient
- `cd` [-]: Drag coefficient
- `cd0` [-]: Parasitic drag coefficient
- `e` [-]: Oswald efficiency factor
- `b1` [m]: Span of the front wing
- `b2` [m]: Span of the rear wing
- `A` [-]: Wing aspect ratio
- `S1` [m^2]: Wing area of the front wing
- `S2` [m^2]: Wing area of the rear wing
- `S` [m^2]: Total wing area
- `c_root1` [m]: Root chord of the front wing
- `c_root2` [m]: Root chord of the rear wing
- `c_tip1` [m]: Tip chord of the front wing
- `c_tip2` [m]: Tip chord of the rear wing
- `sweep_le1` [deg]: Sweep angle of the leading edge of the front wing
- `sweep_le2` [deg]: Sweep angle of the leading edge of the rear wing
- `taper1` [-]: Taper ratio of the front wing
- `taper2` [-]: Taper ratio of the rear wing
- `StotS` [-]: Total area including fuselage over wing surface area
- `ducted_bool`: Does this concept use ducted fans or open propellers (1=ducted, 0=openprop)
